/*JF: programa para leer del laser y mostrar en pantalla la lista de puntos leidos*/

#include "serial.h"
#include "rs4.h"
#include "math.h"



/*JF: Definicion de puerto*/
portstream_fd _port;


/*JF: Variables para almacenar datos claves tomados de la trama del RS4*/
//extern int output_start, output_stop, resolution;

/*JAC NO SE USA double det(double a11, double a12, double a13,
		   double a21, double a22, double a23,
		   double a31, double a32, double a33); */

struct Datos_circulos{
	int numcircles;
	double x0[133];
	double y0[133];
	double r[133];
	double range[133];
	double bearing[133];
};

double norm3(double *v);
int buscacirculos(Datos_RS4 data, Datos_circulos *circulos);
int conjugate_gradient2(int elprimero,int elultimo,double *x,double *y,double *xcentro,double *ycentro,double *radio);

int main(void) {
	
	
	//A:JF: Datos de inicialiacion del RS4 {resolution, star, stop,...} valores por defecto 1 0 0 0
	Datos_RS4 data={1};
	//unsigned char unbyte;
	//long limit_k;
	//long timeout=-1;
	
	/*B:JF:Se abre puerto serial COM2*/
	_port = openserial("COM1");
     	     
	/*B:JF: Seguridad */
	if (_port == NULL)  return(FALSE); 
	
	/*C:JF: Funcion de sincronizacion y lectura de parametros del RTScan*/
	if(!sincronizar_jf(_port,&data)) return(FALSE); 
	
	Datos_circulos circulos={1};
	
    /*JF: Se Lee ciclicamente la trama */
    do
	{
		/*D:JF: Se recupera el mensaje completo.La cadena se empieza a guardar desde la posicion cero
		  para el byte del commando quien precede a los dos 0x00 del inicio de la cadena pero
	      eso sucede solo despues de llamar a la funcion Enganche, despues empieza desde el token de start */
		if(!leer_trama_jf(_port,&data))  return(FALSE); 

        
        /*JF: Se procesan los datos de usuario de la trama para deducir las distancias*/
        proc_datos_jf(&data);
	    //
		//JF:AQUI DEBE COLOCARSE EL CODIGO DE GRAFICACION O DE PROCESAMIENTO ADICIONAL

		buscacirculos(data, &circulos);		
		
		//JAC: Ver que pasa con los relojes aqui!! Sleep(60);
		//JF:El ciclo se repite hasta que se presione una tecla
		}while(!kbhit());
	
	/*JF: Llamada a la funcion de lectura de datos 
					se leen los datos hasta que se presiona tecla*/
			//if(!Mess_jf(_port,&data)) {	printf("laser Mal, no he leido del laser\n");	} 
				
	/*JF: Se imprime parte de los datos de conf. del RS4 tomados de la trama enviada*/ 
    printf("\nEl valor de la resol es %d\n",data.resolution);
    printf("El valor del start es %d\n",data.output_start);
	printf("El valor del stop es %d\n",data.output_stop);
	printf("TamaNo de la Info es %d\n",data.Tam_info);
	printf("El numero maximo de caracteres es %d\n",data.Num_max_char);
	printf("Presione s para salir!\n");

/*	int i=0;


	// graba los puntos en un fichero
	FILE *fp;
	fp=fopen("datos.dat","w");	
	for (i=0;i<numpoints;i++) {
		fprintf(fp,"%f ",data.contourjf[i]);
	}
	fclose(fp);

	// escoje los puntos que estan separados una distancia menor de
	double d1 = 0.1; // metros
	// y que tienen una curvatura mayor de
	double r0 = 0.01; // metros
	// y menor de
	double r1 = 0.1; // metros


	int *indices;
	double *x, *y, *theta;
	double da2, db2, a,d,e,f,x0,y0,r2;

	indices = (int*)malloc(numpoints*sizeof(int));
	x = (double*)malloc(numpoints*sizeof(double));
	y = (double*)malloc(numpoints*sizeof(double));
	theta = (double*)malloc(numpoints*sizeof(double));
	fp=fopen("xyth.dat","w");
	for(i=0; i<numpoints;i++) {
		indices[i] = 0;
		theta[i] = (190.0/((double)numpoints-1.0)*((double)i)-5.0)*PI/180.0;
		x[i]=data.contourjf[i]*cos(theta[i]);
		y[i]=data.contourjf[i]*sin(theta[i]);		
		fprintf(fp,"%f %f %f\n",x[i],y[i],theta[i]);
	}
	fclose(fp);
	fp=fopen("indices.dat","w");
	fprintf(fp,"%d %f %f %f\n",0,0.0,0.0,0.0);
	for(i=1; i<numpoints-1;i++) {
		da2 = (x[i]-x[i-1])*(x[i]-x[i-1]) + (y[i]-y[i-1])*(y[i]-y[i-1]);
		db2 = (x[i+1]-x[i])*(x[i+1]-x[i]) + (y[i+1]-y[i])*(y[i+1]-y[i]);
		if(da2<(d1*d1) && db2<(d1*d1)) {
			a = det(x[i-1], y[i-1], 1.0, x[i], y[i], 1.0, x[i+1], y[i+1], 1.0);
			d = -det(x[i-1]*x[i-1]+y[i-1]*y[i-1], y[i-1], 1.0, x[i]*x[i]+y[i]*y[i], y[i], 1.0, x[i+1]*x[i+1]+y[i+1]*y[i+1], y[i+1], 1.0);
			e = det(x[i-1]*x[i-1]+y[i-1]*y[i-1], x[i-1], 1.0, x[i]*x[i]+y[i]*y[i], x[i], 1.0, x[i+1]*x[i+1]+y[i+1]*y[i+1], x[i+1], 1.0);
			f = -det(x[i-1]*x[i-1]+y[i-1]*y[i-1], x[i-1], y[i-1], x[i]*x[i]+y[i]*y[i], x[i], y[i], x[i+1]*x[i+1]+y[i+1]*y[i+1], x[i+1], y[i+1]);
			x0 = -d/(2*a);
			y0 = -e/(2*a);
			r2 = (d*d+e*e)/(4*a*a)-f/a;
			if(r2>(r0*r0) && r2<(r1*r1))
				indices[i] = 1;			
		}
		fprintf(fp,"%d %f %f %f\n",indices[i],x0,y0,r2);
	}
	fprintf(fp,"%d %f %f %f\n",0,0.0,0.0,0.0);
	fclose(fp);
*/

    /*JF: Se cierra el puerto serial */ 
	closeserial(_port);
    
	/*JF: Esperamos hasta que se presione 's' para salir.*/
    for(;;){ if(getch()=='s') break;}

	return(0);
}


int buscacirculos(Datos_RS4 data, Datos_circulos *circulos) {

	int i, blobindex, numpoints;
	double *x, *y, *theta, db2;

	numpoints = (data.output_stop-data.output_start)/data.resolution+1;

	x = (double*)malloc(numpoints*sizeof(double));
	y = (double*)malloc(numpoints*sizeof(double));
	theta = (double*)malloc(numpoints*sizeof(double));
	for(i=0; i<numpoints;i++) {
		theta[i] = (190.0/((double)numpoints-1.0)*((double)i)-5.0)*PI/180.0;
		x[i]=data.contourjf[i]*cos(theta[i]);
		y[i]=data.contourjf[i]*sin(theta[i]);		
	}

	double d2 = 0.05; // cada blob debe estar separado mas de 5 cm
	int *indices2;
	indices2 = (int*)malloc(numpoints*sizeof(int));
	blobindex=0;
	indices2[0] = blobindex;
	for(i=0;i<numpoints-1;i++) {
		db2 = (x[i+1]-x[i])*(x[i+1]-x[i]) + (y[i+1]-y[i])*(y[i+1]-y[i]); // dist cuad
		if(db2>(d2*d2))
			blobindex++;
		indices2[i+1] = blobindex;
	}

	// hacer blobindex veces el conjugate gradient para encontrar los parametros del circulo
	// que haga mejor fit	

	double minradio = 0.03;  // 3 cm
	double maxradio = 0.08;  // 8 cm

	int elprimero, elultimo, circleindex;
	double xcentro,ycentro,radio;
	elprimero = 0;
	elultimo = 0;
	blobindex = 0;
	circleindex = 0;

	for(i=0;i<numpoints;i++) {
		if(indices2[i] > blobindex) {
			elultimo = i;
			if(elultimo-elprimero >3) {
				conjugate_gradient2(elprimero,elultimo,x,y,&xcentro,&ycentro,&radio);
				if((radio> minradio) && (radio < maxradio)) {
					printf("%f %f %f %f %f\n", xcentro, ycentro, radio, sqrt(xcentro*xcentro+ycentro*ycentro), atan2(ycentro,xcentro));
					circulos->x0[circleindex] = xcentro;
					circulos->y0[circleindex] = ycentro;
					circulos->r[circleindex] = radio;
					circulos->range[circleindex] = sqrt(xcentro*xcentro+ycentro*ycentro);
					circulos->bearing[circleindex] = atan2(ycentro,xcentro);
					circleindex++;
				}
			}
			blobindex = indices2[i];
			elprimero = elultimo;
		}
	}
	printf("\n");
	circulos->numcircles=circleindex;

	free(indices2);
	free(x);
	free(y);
	free(theta);

	return 0;

}

/* double det(double a11, double a12, double a13,
		   double a21, double a22, double a23,
		   double a31, double a32, double a33) {
	return a11*a22*a33-a11*a23*a32-a21*a12*a33+a21*a13*a32+a31*a12*a23-a31*a13*a22;
}

int conjugate_gradient(int elprimero,int elultimo,double *x,double *y,double *xcentro,double *ycentro,double *radio) {
	double Q[3][3], b[3], xx[3], g[3], d[3], epsilon, alpha, beta;
	int i,j,n;

	// define Q and b for .5x'Qx-x'b
	// minimize using conjugate gradient pp.140 libro de optimizacion Chong
	n=elultimo-elprimero;
	for(i=0;i<3;i++) {
		for(j=0;j<3;j++)
			Q[i][j] = 0.0;
		Q[i][i] = 2*n;
		b[i] = 0.0;
	}
	Q[2][2] = -2*n;
	for(i=elprimero;i<elultimo;i++) {
		b[0] += 2*x[i];
		b[1] += 2*y[i];
	}

	// select initial xx (x0) como el promedio de los puntos y radio 1.0
	xx[0] = 0.0;
	xx[1] = 0.0;
	xx[2] = 1.0;
	for(i=elprimero;i<elultimo;i++) {
		xx[0] += x[i]/(double)n;
		xx[1] += y[i]/(double)n;
	}
	// set g(0)=grad(f(x(0)). If g(0) = 0 stop, else d(0)=-g(0)
	g[0] =  2*n*xx[0]-b[0];
	g[1] =  2*n*xx[1]-b[1];
	g[2] = -2*n*xx[2]-b[2];

	d[0] = -g[0];
	d[1] = -g[1];
	d[2] = -g[2];

	epsilon = 1e-6;

	while(g[0]*g[0]+g[1]*g[1]+g[2]*g[2] > epsilon) {

		// alphak = -g'd/d'Qd
		alpha = (-g[0]*d[0]-g[1]*d[1]-g[2]*d[2])/((d[0]*Q[0][0]+d[1]*Q[1][0]+d[2]*Q[2][0])*d[0]+(d[0]*Q[0][1]+d[1]*Q[1][1]+d[2]*Q[2][1])*d[1]+(d[0]*Q[0][2]+d[1]*Q[1][2]+d[2]*Q[2][2])*d[2]);

		// xk+1=xk+alphak dk
		xx[0] = xx[0] + alpha * d[0];
		xx[1] = xx[1] + alpha * d[1];
		xx[2] = xx[2] + alpha * d[2];
		
		// gk+1 = grad(f(x(k)). If g(k+1) = 0; stop
		g[0] =  2*n*xx[0]-b[0];
		g[1] =  2*n*xx[1]-b[1];
		g[2] = -2*n*xx[2]-b[2];

		if (g[0]*g[0]+g[1]*g[1]+g[2]*g[2] < epsilon)
			break;

		// beta = g'Qd/d'Qd
		beta = ((g[0]*Q[0][0]+g[1]*Q[1][0]+g[2]*Q[2][0])*d[0]+(g[0]*Q[0][1]+g[1]*Q[1][1]+g[2]*Q[2][1])*d[1]+(g[0]*Q[0][2]+g[1]*Q[1][2]+g[2]*Q[2][2])*d[2])/((d[0]*Q[0][0]+d[1]*Q[1][0]+d[2]*Q[2][0])*d[0]+(d[0]*Q[0][1]+d[1]*Q[1][1]+d[2]*Q[2][1])*d[1]+(d[0]*Q[0][2]+d[1]*Q[1][2]+d[2]*Q[2][2])*d[2]);
 
		// dk+1 = -gk+1+betadk
		d[0] = -g[0]+ beta * d[0];
		d[1] = -g[1]+ beta * d[1];
		d[2] = -g[2]+ beta * d[2];

	}
	*xcentro = xx[0];
	*ycentro = xx[1];
	*radio = xx[2];
	return 0;
} */

int conjugate_gradient2(int elprimero,int elultimo,double *x,double *y,double *xcentro,double *ycentro,double *radio) {
	double epsilon, g[3], d[3], beta, xi, yi, x0, y0, r, dd, dd3, xx2, yy2, xx[3], Q[3][3], alpha, numerator, denominator;
	int n, i, j, k;
	div_t div_result;

	epsilon = 1e-6;
	n=elultimo-elprimero;

	// select initial xx (x0) como el promedio de los puntos y radio 0.0
	for(i=0;i<3;i++)
		xx[i] = 0.0;
	for(i=elprimero;i<elultimo;i++) {
		xx[0] += x[i]/(double)n;
		xx[1] += y[i]/(double)n;
	}

	for(i=0;i<3;i++) {
		g[i] = 1.0;
		d[i] = 0.0;
	}
	beta = 0.0;
	k = 1;


	while(norm3(g)>epsilon) {
		for(i=0;i<3;i++) {
			for(j=0;j<3;j++) {
				Q[i][j] = 0;
			}
			g[i] = 0;
		}
		x0 = xx[0];
        y0 = xx[1];
        r = xx[2];
		for(i=elprimero;i<elultimo;i++) {
			xi = x[i];
			yi = y[i];
        
			dd = sqrt(xi*xi-2*xi*x0+x0*x0+yi*yi-2*yi*y0+y0*y0);
			dd3 = dd*dd*dd;
			xx2 = -2*xi+2*x0;
			yy2 = -2*yi+2*y0;
			g[0] = g[0] + xx2*(1.0-r/dd);
			g[1] = g[1] + yy2*(1.0-r/dd); 
			g[2] = g[2] + 2*(r-dd);
 
			Q[0][0] = Q[0][0] + 2 + r/(2*dd3)*xx2*xx2-2*r/dd;
			Q[0][1] = Q[0][1] +	r/(2*dd3)*xx2*yy2;
			Q[0][2] = Q[0][2] - 1/dd*xx2;
	
		    Q[1][0] = Q[1][0] +  r/(2*dd3)*xx2*yy2;
			Q[1][1] = Q[1][1] + 2 + r/(2*dd3)*yy2*yy2-2*r/dd;
			Q[1][2] = Q[1][2] - 1/dd*yy2;

			Q[2][0] = Q[2][0] - 1/dd*xx2;
			Q[2][1] = Q[2][1] - 1/dd*yy2;
			Q[2][2] = Q[2][2] + 2;
		}

	    div_result = div(n,k);
		if(div_result.rem > 0) 
			for(i=0;i<3;i++)
				d[i] = -g[i]+beta*d[i];
		else 
			for(i=0;i<3;i++)
				d[i] = -g[i];

		numerator = g[0]*d[0]+g[1]*d[1]+g[2]*d[2];
		denominator = (d[0]*Q[0][0]+d[1]*Q[1][0]+d[2]*Q[2][0])*d[0]+(d[0]*Q[0][1]+d[1]*Q[1][1]+d[2]*Q[2][1])*d[1]+(d[0]*Q[0][2]+d[1]*Q[1][2]+d[2]*Q[2][2])*d[2];
		alpha = -numerator/denominator;

		for(i=0;i<3;i++)
			xx[i] = xx[i] + alpha*d[i];

		numerator = (g[0]*Q[0][0]+g[1]*Q[1][0]+g[2]*Q[2][0])*d[0]+(g[0]*Q[0][1]+g[1]*Q[1][1]+g[2]*Q[2][1])*d[1]+(g[0]*Q[0][2]+g[1]*Q[1][2]+g[2]*Q[2][2])*d[2];
		beta = numerator/denominator;
	    k++;
		if (k>500)
			break;
    }

	*xcentro = xx[0];
	*ycentro = xx[1];
	*radio = xx[2];

	return 0;
}

double norm3(double *v) {
	return(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
}

