function done=pruebaconjgrad(xy)
% fichero que prueba el conjugate gradient con 3 puntos que hacen el best fit a un circulo

epsilon = 1e-6
%xy = [1 2 2 ;  1 1 2 ]
n = size(xy,2)


plot(xy(1,:),xy(2,:),'xb');

% initial conditions
x = [sum(xy')';0]/n

g=[1;1;1];
d=[0;0;0];
beta = 0;
j=0;
while(norm(g)>epsilon)
    g = zeros(3,1);
    Q = zeros(3,3);
    for i=1:n
        xi = xy(1,i);
        yi = xy(2,i);
        x0 = x(1);
        y0 = x(2);
        r = x(3);
        g = g + [-2*xi+2*x0-r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*xi+2*x0);
                 -2*yi+2*y0-r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*yi+2*y0);                    
                        2*r-2*(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)];
 
        Q = Q + [ 2+1/2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(3/2)*(-2*xi+2*x0)^2-2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2), 1/2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(3/2)*(-2*xi+2*x0)*(-2*yi+2*y0), -1/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*xi+2*x0);
                    1/2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(3/2)*(-2*xi+2*x0)*(-2*yi+2*y0), 2+1/2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(3/2)*(-2*yi+2*y0)^2-2*r/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2), -1/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*yi+2*y0);
                       -1/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*xi+2*x0), -1/(xi^2-2*xi*x0+x0^2+yi^2-2*yi*y0+y0^2)^(1/2)*(-2*yi+2*y0), 2];
    end;

    Q;
    if(mod(n,j))
        d = -g+beta*d;
    else
        d = -g;
    end;
    alpha = -g'*d/(d'*Q*d);
    xold = x;
    x = x + alpha*d;
    norm(g);
    beta = g'*Q*d/(d'*Q*d);
    line([xold(1) x(1)],[xold(2) x(2)]);
    plot(x(1),x(2),'xb');
    j=j+1;
    if (j>500)
        break;
    end;
end;

x
j

%if((x(3)>0.03) & (x(3) <0.08))
    circle(x(1),x(2),x(3),'r',1);
    txt = sprintf('%f',x(3));
    text(x(1),x(2),txt);
    %end;


return;

